{*******************************************************************************

  Advanced Application Controls v3.0
  FILE: _AACReg.pas - Components Registration and Property Editors.

  Copyright (c) 1998-2004 UtilMind Solutions
  All rights reserved.
  E-Mail: info@utilmind.com
  WWW: http://www.utilmind.com, http://www.appcontrols.com

  The entire contents of this file is protected by International Copyright
Laws. Unauthorized reproduction, reverse-engineering, and distribution of all
or any portion of the code contained in this file is strictly prohibited and
may result in severe civil and criminal penalties and will be prosecuted to
the maximum extent possible under the law.

*******************************************************************************}
{$I umDefines.inc}

unit _AACReg;

interface

procedure Register;

implementation

uses Windows, Classes, Controls, Graphics, Forms, StdCtrls, ComCtrls,
     Dialogs, TypInfo, SysUtils, FileCtrl,
     {$IFDEF D5} Menus, ImgList, {$ENDIF}
{$IFDEF D6}
     DesignIntf, DesignEditors, DesignMenus, VCLEditors, acIDEEditorsD6, PicEdit,
{$ELSE}
     DsgnIntf, acIDEEditors,
{$ENDIF}
{$IFDEF USETHEMEENGINE}
     te_controls,
{$ENDIF}
     acFormHelpReg, acAbout, acClasses, acGraphics,
     acPropUtils, acRichTextUtils,
     acInet, acHTTP, {$IFDEF D4} acHTTPDownloadQueue, acRSSFeed, {$ENDIF}
     acSendMail, acAppAutoRun, acAppStartCounter, acAppBar,
     acAutoUpgrader, acAppEvents, acAppCursors, acAppGlobalAlert,
     acOnlyOne, acTimer, acAwayTimer,
     acShortcut, acExtAssociation, acEmbeddedForm, acTrayIcon,
     acCaptionButton, acAnimationEffect, acWin2kEffects, acFormHelp,
     acFormHints, acFormMagnet, acFormSystemMenu,
     acFormTopmost, acFormRoller, acFormPlacementSaver,
     acFormSizeRestrictions, acFormResizeGrip, acFormHook,
     acFormBackground, acFileStorage, acWavPlayer, acUnixCrypt,
     acCursorLocker, acThread, acThreadSafeLog, acQuickAboutBox, acSystemInfo,
     acDesktopWallpaper, acControlKeyState, acDateTimeCalc,
     acSimpleTCP, acInfoBox, acClipboard,
     {$IFDEF D4} {$IFNDEF BCB} acProcessList, {$ENDIF} acConnectionList, {$ENDIF}

     acControls, acRichLabel, acLabels, acAttachedLabel,
     {$IFNDEF D3} acSplitterD2, {$ENDIF} acButtons, acButtonsPanel, acEdit, acIPEdit,
     acPanel, acSplitterPanel, acHeaderPanel, acPicturePanel, acDragPanel,
     acComboDatePicker, acPropImage, acWebImage, {$IFDEF USEINTERNAL} acListImage, {$ENDIF}
     acLabeledComboBox, acMRUComboBox,
     {$IFDEF D5} acApartPopupMenu, {$ENDIF} acTrackBar, acImagesComboBox,
     acTreeComboBox, acComCtrls, acSystemImageList, acStatusControl,
     acHostnameResolver, acStringListContainer,
     {$IFDEF D3} acLinksPanel, acTextTemplateConverter, {$ENDIF}

     {$IFDEF USEDB} acSQLQueryThread, acDBListView, {$ENDIF}
     {$IFDEF USEINTERNAL} acInternal, {$IFDEF D3}acProgressBox,{$ENDIF}{$ENDIF}
     {$IFDEF D5} acHTMLViewer, acIESniffer, acIESnifferAutoFillUserInfo,
     {$IFDEF USEINTERNAL}acMySQL, acMySQLListComboBox,{$ENDIF}{$ENDIF}
     acUtils,

     acStringEditor, acRichTextEditor, acProxyEditor,
     acSendMailRecipientEditor, acAutoUpgraderEditor,
     {$IFDEF D3} acAutoUpgraderDateEditor, {$ENDIF}
     {$IFDEF USETHEMEENGINE} acAutoUpgraderWizardTe, {$ELSE} acAutoUpgraderWizard, {$ENDIF}
     acFileStorageEditor, acPicEdit;

const
  acVersion = 'v3.8.1';

type
{$IFDEF D5}
  {$IFNDEF D6}
  IMenuItem = TMenuItem;
  IProperty = TPropertyEditor;
  {$ENDIF}
{$ENDIF}

{$IFNDEF D4}
  IDesigner = TDesigner;
  IFormDesigner = TFormDesigner;
{$ENDIF}

{$IFNDEF D5}
  TComponents = TComponentList;
  IComponents = TComponentList;
{$ELSE}
  {$IFNDEF D6}
  TComponents = TDesignerSelectionList;
  IComponents = TDesignerSelectionList;
  {$ELSE}
  TComponents = TDesignerSelections;
  IComponents = IDesignerSelections;
  {$ENDIF}
{$ENDIF}

{*******************************************************************************
  About property editor for all App Controls, implements About dialog.
*******************************************************************************}
 { TacAboutProperty }
  TacAboutProperty = class(TStringProperty)
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
    function  GetValue: String; override;
  end;

{*******************************************************************************
  Default component editor for all App Controls, implements About dialog.
*******************************************************************************}
  { TacComponentEditor }
  TacComponentEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  Read-only (but visible at design-time) Enumeration property (i.e: TdcDriveType for dcDiskInfo)
*******************************************************************************}
 { TacROEnumProperty }
  TacROEnumProperty = class(TEnumProperty)
    function  GetAttributes: TPropertyAttributes; override;
  end;

{*******************************************************************************
  Read-only (but visible at design-time) Integer type property
*******************************************************************************}
 { TacROIntegerProperty }
  TacROIntegerProperty = class(TIntegerProperty)
    function  GetAttributes: TPropertyAttributes; override;
  end;

{*******************************************************************************
  Read-only (but visible at design-time) TStrings property
*******************************************************************************}
 { TacROStringListProperty }
  TacROStringListProperty = class(TClassProperty)
    function  GetAttributes: TPropertyAttributes; override;
  end;

{$IFDEF D6}
{*******************************************************************************
  Read-only (but visible at design-time) TGraphic property
*******************************************************************************}
 { TacROGraphicProperty }
  TacROGraphicProperty = class(TGraphicProperty)
    function  GetAttributes: TPropertyAttributes; override;
  end;
{$ENDIF}  

{*******************************************************************************
  Template for "TStringProperties"
*******************************************************************************}
 { TacStringProperty }
  TacStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
  end;

{*******************************************************************************
  Multiline string PROPERTY editor for ac_xxx controls
*******************************************************************************}
 { TacMultilineStringProperty }
  TacMultilineStringProperty = class(TCaptionProperty)
  public
    function GetEditLimit: Integer; override;
    function GetAttributes: TPropertyAttributes; override;    
    procedure Edit; override;
  end;

{*******************************************************************************
  RichText PROPERTY editor for ac_xxx controls
*******************************************************************************}
 { TacRichTextProperty }
  TacRichTextProperty = class(TCaptionProperty)
  public
    function GetEditLimit: Integer; override;
    function GetAttributes: TPropertyAttributes; override;    
    procedure Edit; override;
  end;


{*******************************************************************************
  ClearCounter property for acAppStartCounter
*******************************************************************************}
 { TacAppStartCounterCompEditor }
  TacAppStartCounterCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  Proxy structure PROPERTY editor for acCustomHTTP
*******************************************************************************}
 { TacHTTPProxyProperty }
  TacHTTPProxyProperty = class(TClassProperty)
  public
    function GetValue: String; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

{*******************************************************************************
  VersionInfo/Upgrade Message PROPERTY editor for AugoUpgrader
*******************************************************************************}
 { TacAutoUpgraderProperty }
  TacAutoUpgraderProperty = class(TClassProperty)
  public
    function GetValue: String; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

{$IFDEF D3}
{*******************************************************************************
  VersionDate PROPERTY editor for AugoUpgrader
*******************************************************************************}
 { TacAutoUpgraderVersionDateProperty }
  TacAutoUpgraderVersionDateProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;
{$ENDIF}  

{*******************************************************************************
  COMPONENT editor for AugoUpgrader
*******************************************************************************}
 { TacAutoUpgraderCompEditor }
  TacAutoUpgraderCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{$IFDEF D4}
{*******************************************************************************
  COMPONENT editor for RSSFeed component
*******************************************************************************}
 { TacRSSFeedCompEditor }
  TacRSSFeedCompEditor = class(TacComponentEditor)
  private
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  COMPONENT editor for RSSFeedContainer component
*******************************************************************************}
 { TacRSSFeedContainerCompEditor }
  TacRSSFeedContainerCompEditor = class(TacComponentEditor)
  private
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;
{$ENDIF}

{*******************************************************************************
  Recipients for acSendMail
*******************************************************************************}
 { TacSendMailRecipientsProperty }
  TacSendMailRecipientsProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  FileName property editor
*******************************************************************************}
  TacFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  IniFile property editor
*******************************************************************************}
  TacIniFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  XMLFile property editor
*******************************************************************************}
  TacXMLFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  Executable property editor
*******************************************************************************}
  TacExecutableFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  Shortcut property editor
*******************************************************************************}
  TacShortcutFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  ThreadSafeLog property editor
*******************************************************************************}
  TacThreadSafeLogFileNameProperty = class(TacStringProperty)
  public
    procedure Edit; override;
  end;

{*******************************************************************************
  Folder property editor
*******************************************************************************}
  TacFolderProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{*******************************************************************************
  Shortcut component editor - implements file open dialog (for .lnk files only) on doubleclick
*******************************************************************************}
  TacShortcutCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  Clipobard component editor - adds "Clear" menu item to component menu
*******************************************************************************}
  TacClipboardCompEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  StoredFiles property editor for FileStorage component
*******************************************************************************}
 { TacStoredFilesProperty }
 TacStoredFilesProperty = class(TPropertyEditor)
 public
   procedure Edit; override;
   function GetValue: String; override;
   function GetAttributes: TPropertyAttributes; override;
 end;

{*******************************************************************************
  StoredFiles component editor for FileStorage component
*******************************************************************************}
 { TacFileStorageCompEditor }
 TacFileStorageCompEditor = class(TacComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  WaveFile PROPERTY editor for WavPlayer
*******************************************************************************}
 { TacWavPlayerProperty }
  TacWavPlayerWavFileProperty = class(TClassProperty)
  public
    function GetValue: String; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

{*******************************************************************************
  WavFile COMPONENT editor for WavPlayer
*******************************************************************************}
 { TacWavPlayerCompEditor }
  TacWavPlayerCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{$IFDEF USEINTERNAL}
{$IFDEF D3}
{*******************************************************************************
  ProgressBox COMPONENT editor for acProgressBox
*******************************************************************************}
{ TacProgressBoxCompEditor }
  TacProgressBoxCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;
{$ENDIF}  
{$ENDIF}

{*******************************************************************************
  InfoBox COMPONENT editor for acInfoBox 
*******************************************************************************}
{ TacInfoBoxCompEditor }
  TacInfoBoxCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  SplitterPanel COMPONENT editor for acSplitterPanel
*******************************************************************************}
 { TacSplitterPanelCompEditor }
 TacSplitterPanelCompEditor = class(TacComponentEditor)
 public
   procedure ExecuteVerb(Index: Integer); override;
   function GetVerbCount: Integer; override;
   function GetVerb(Index: Integer): String; override;
   {$IFDEF D5}
   procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
   {$ENDIF}
 end;

{*******************************************************************************
  TreeView COMPONENT editor for acListView
*******************************************************************************}
 { TacTreeViewCompEditor }
  TacTreeViewCompEditor = class(TacComponentEditor)
  private
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
  end;

{*******************************************************************************
  ListView COMPONENT editor for acListView
*******************************************************************************}
 { TacListViewCompEditor }
  TacListViewCompEditor = class(TacComponentEditor)
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
  end;

{$IFDEF USEDB}
{*******************************************************************************
  DBListView COMPONENT editor for acDBListView
*******************************************************************************}
 { TacDBListViewCompEditor }
  TacDBListViewCompEditor = class(TacComponentEditor)
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
  end;
{$ENDIF}


{*******************************************************************************
  QuickAboutBox COMPONENT editor
*******************************************************************************}
 { TacQuickAboutBoxCompEditor }
  TacQuickAboutBoxCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{$IFDEF D3}
{*******************************************************************************
  TextTemplateConverter COMPONENT editor
*******************************************************************************}
 { TacTextTemplateConverterCompEditor }
  TacTextTemplateConverterCompEditor = class(TacComponentEditor)
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{*******************************************************************************
  LinksPanel COMPONENT editor
*******************************************************************************}
 { TacLinksPanelCompEditor }
  TacLinksPanelCompEditor = class(TacComponentEditor)
    FPropName: String;
{$IFNDEF D6}
    procedure FindProperty(PropertyEditor: TPropertyEditor); virtual;
{$ELSE}
    procedure FindProperty(const PropertyEditor: IProperty); virtual;
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;
{$ENDIF}  

{*******************************************************************************
  Wallpaper PROPERTY editor for DesktopWallpaper
*******************************************************************************}
 { TacWallpaperProperty }
  TacWallpaperProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;


{*******************************************************************************
  acURLLabel COMPONENT editor
*******************************************************************************}
 { TacURLLabelCompEditor }
  TacURLLabelCompEditor = class(TacComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    {$IFDEF D5}
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    {$ENDIF}
  end;

{$IFDEF D5}
{*******************************************************************************
  ImageIndex property for all components that manage ImageLists
*******************************************************************************}
  TacImageIndexProperty = class(TIntegerProperty{$IFDEF D6}, ICustomPropertyListDrawing{$ENDIF})
  protected
    function GetImages: TCustomImageList; virtual;
    property Images: TCustomImageList read GetImages;
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure ListMeasureWidth(const Value: String; ACanvas: TCanvas;
      var AWidth: Integer); {$IFNDEF D6}override;{$ENDIF}
    procedure ListMeasureHeight(const Value: String; ACanvas: TCanvas;
      var AHeight: Integer); {$IFNDEF D6}override;{$ENDIF}
    procedure ListDrawValue(const Value: String; ACanvas: TCanvas;
      const ARect: TRect; ASelected: Boolean); {$IFNDEF D6}override;{$ENDIF}
  end;
{$ENDIF}
  

{ *** implementation for property editors *** }

{ TacAboutProperty }
procedure TacAboutProperty.Edit;
begin
  acShowAbout(TComponent(GetComponent(0)).ClassName);
end;

function TacAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly, paDialog];
end;

function TacAboutProperty.GetValue: String;
begin
  Result := acVersion;
end;


{ TacComponentEditor}
procedure TacComponentEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 1 then
    acShowAbout(Component.ClassName)
  else inherited ExecuteVerb(Index);
end;

function TacComponentEditor.GetVerb(Index: Integer): string;
begin
  if Index = GetVerbCount - 1 then
    Result := 'About...'
  else
    Result := inherited GetVerb(Index);
end;

function TacComponentEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

{$IFDEF D5}
procedure TacComponentEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 1) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
  else
{$ENDIF}  
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacROEnumProperty }
function  TacROEnumProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly];
end;

{ TacROIntegerProperty }
function  TacROIntegerProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly];
end;

{ TacROStringListProperty }
function  TacROStringListProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly, paDialog] - [paSubProperties];
end;

{$IFDEF D6}
{ TacROGraphicProperty }
function  TacROGraphicProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly];
end;
{$ENDIF}


{ TacStringProperty}
function TacStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;


{ TacMultilineStringProperty }
function TacMultilineStringProperty.GetEditLimit: Integer;
begin
  if GetPropType^.Kind = tkString then
    Result := GetTypeData(GetPropType)^.MaxLength
  else Result := 1024;
end;

function TacMultilineStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

procedure TacMultilineStringProperty.Edit;
var
  Comp: TPersistent;
  St: String;
begin
  with TacStringEditor.Create(Application) do
  try
    Comp := GetComponent(0);
    if Comp is TComponent then
      Caption := TComponent(Comp).Name + '.' + GetName
    else Caption := GetName;
    Memo.Text := GetStrValue;
    Memo.MaxLength := GetEditLimit;
    if ShowModal = mrOk then
     begin
      St := Memo.Text;
      while (Length(St) > 0) and (St[Length(St)] < ' ') do
        System.Delete(St, Length(St), 1);
      SetStrValue(St);
     end;
  finally
    Free;
  end;
end;


{ TacRichTextProperty }
function TacRichTextProperty.GetEditLimit: Integer;
begin
  if GetPropType^.Kind = tkString then
    Result := GetTypeData(GetPropType)^.MaxLength
  else Result := 1024;
end;

function TacRichTextProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

procedure TacRichTextProperty.Edit;
var
  Comp: TPersistent;
  St: String;
begin
  with TacRichTextEditor.Create(Application) do
   try
     GTagOpen := DEFAULT_TAG_OPEN;
     GTagClose := DEFAULT_TAG_CLOSE;

     Comp := GetComponent(0);
     if Comp is TComponent then
       Caption := TComponent(Comp).Name + '.' + GetName
     else Caption := GetName;

     if Comp is TacRichLabel then
      begin
       GTagOpen := TacRichLabel(Comp).TextStyle.TagOpen;
       GTagClose := TacRichLabel(Comp).TextStyle.TagClose;
      end;

     TagEditor.Text := GetStrValue;
     TagToRich(TagEditor.Text, RichEditor, GTagOpen, GTagClose);
     RichEditor.MaxLength := GetEditLimit;
     if ShowModal = mrOk then
      begin
       if not TagEditor.Visible then
         TagEditor.Text := RichToTag(RichEditor, GTagOpen, GTagClose);
       St := TagEditor.Text;
       while (Length(St) > 0) and (St[Length(St)] < ' ') do
         System.Delete(St, Length(St), 1);
       SetStrValue(St);
      end;
   finally
     Free;
   end;
end;


{ TacAppStartCounterCompEditor }
procedure TacAppStartCounterCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    if Application.MessageBox('Reset Start Counter on this machine ?', PChar(Component.Name), mb_YesNo or mb_IconQuestion) = id_Yes then
     begin
      TacAppStartCounter(Component).ResetCounter;
      Designer.Modified;
     end
    else
  else inherited ExecuteVerb(Index);
end;

function TacAppStartCounterCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacAppStartCounterCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&Reset Counter'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacAppStartCounterCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 3) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACRESET')
  else
{$ENDIF}  
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacHTTPProxyProperty Editor }
function TacHTTPProxyProperty.GetValue: String;
begin
  Result := '(Proxy settings)';
end;

function TacHTTPProxyProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paSubProperties, paDialog];
end;

procedure TacHTTPProxyProperty.Edit;
var
  Component: TPersistent;
begin
  Component := GetComponent(0);
{$IFDEF AUTOUPGRADERPROXY}
  if Component is TacAutoUpgrader then
    ShowProxyDesigner(Designer, TacAutoUpgrader(Component).Proxy)
  else
{$ENDIF}
{$IFDEF D4}
    if Component is TacHTTPDownloadQueue then
      ShowProxyDesigner(Designer, TacHTTPDownloadQueue(Component).Proxy)
    else
      if Component is TacRSSFeed then
         ShowProxyDesigner(Designer, TacRSSFeed(Component).HTTPProxy)
      else
        if Component is TacRSSFeedContainer then
          ShowProxyDesigner(Designer, TacRSSFeedContainer(Component).HTTPProxy)
        else
{$ENDIF}      
          ShowProxyDesigner(Designer, TacCustomHTTP(Component).Proxy)
end;


{ TacAutoUpgraderProperty Editor }
function TacAutoUpgraderProperty.GetValue: String;
begin
  Result := '(Upgrade Info)';
end;

function TacAutoUpgraderProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paSubProperties, paDialog];
end;

procedure TacAutoUpgraderProperty.Edit;
begin
  ShowAutoUpgraderDesigner(Designer, TacAutoUpgrader(GetComponent(0)));
end;


{$IFDEF D3}
{ TacAutoUpgraderVersionDateProperty Editor }
procedure TacAutoUpgraderVersionDateProperty.Edit;
begin
  ShowAutoUpgraderVersionDateDesigner(Designer, TacAutoUpgrader(GetComponent(0)));
end;
{$ENDIF}


{ TacAutoUpgraderCompEditor }
procedure TacAutoUpgraderCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    ShowAutoUpgraderDesigner(Designer, TacAutoUpgrader(Component))
  else inherited ExecuteVerb(Index);
end;

function TacAutoUpgraderCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacAutoUpgraderCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then
    Result := '&Edit Info-file...'
  else
    if Index = GetVerbCount - 2 then
      Result := '-'
    else
      Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacAutoUpgraderCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 3) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACEDIT')
  else
   if (Index = GetVerbCount - 1) then
     AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
   else
{$ENDIF}   
     inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{$IFDEF D4}
{ TacRSSFeedCompEditor }
procedure TacRSSFeedCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

  procedure ShowError(const Source: String);
  begin
    MsgBox(Format('Can''t load and parse the RSS Feed from "%s". ' +
      'Perhaps the downloaded document has errors in it''s RSS syntax, or it''s not XML document at all.',
      [Source]), MB_OK or MB_ICONSTOP, 'Can''t load RSS Feed')
  end;

var
  URL: String;
begin
  if Index = GetVerbCount - 8 then
    ExecutePropEditor('FeedItems')
  else
   if Index = GetVerbCount - 6 then
     with TacRSSFeed(Component) do
      begin
       URL := InputBox('Enter URL', 'Please enter the URL to download the RSS feed:', '');
       if URL <> '' then
        begin
         TacRSSFeed(Component).ReadURL(URL, True);
         Designer.Modified;
        end
      end
    else
     if Index = GetVerbCount - 5 then
        with TOpenDialog.Create(Application) do
         try
           DefaultExt := 'xml';
           Filter     := 'XML Files (*.xml)|*.xml|All files (*.*)|*.*';
           Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
           if Execute then
            if not TacRSSFeed(Component).LoadFromFile(FileName) then
              ShowError(FileName)
            else
              Designer.Modified;
         finally
           Free;
         end
     else
      if Index = GetVerbCount - 4 then
        with TSaveDialog.Create(Application) do
         try
           DefaultExt := 'xml';
           Filter     := 'XML Files (*.xml)|*.xml|All files (*.*)|*.*';
           Options    := Options + [ofOverwritePrompt,ofCreatePrompt,ofNoDereferenceLinks];
           if Execute then
             TacRSSFeed(Component).SaveToFile(FileName);
         finally
           Free;
         end
      else
       if Index = GetVerbCount - 3 then
        begin
         TacRSSFeed(Component).Clear;
         Designer.Modified;
        end
       else
         inherited ExecuteVerb(Index);
end;

function TacRSSFeedCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 7;
end;

function TacRSSFeedCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 8 then
    Result := '&Edit Feed Items...'
  else
   if Index = GetVerbCount - 7 then
     Result := '-'
   else
    if Index = GetVerbCount - 6 then
      Result := '&Read RSS from URL...'
    else
      if Index = GetVerbCount - 5 then
        Result := '&Load RSS from disk...'
      else
       if Index = GetVerbCount - 4 then
         Result := '&Save RSS to disk...'
       else
        if Index = GetVerbCount - 3 then
          Result := '&Clear RSS Feed!'
        else
          if Index = GetVerbCount - 2 then
            Result := '-'
          else
            Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacRSSFeedCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 8) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACEDIT')
  else
   if (Index = GetVerbCount - 6) then
     AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
   else
    if (Index = GetVerbCount - 5) then
      AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLOAD')
    else
     if (Index = GetVerbCount - 4) then
       AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACSAVE')
     else
      if (Index = GetVerbCount - 3) then
        AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACDELETE')
      else
       if (Index = GetVerbCount - 2) then
         AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
       else
{$ENDIF}
        inherited PrepareItem(Index, AItem)
end;
{$ENDIF}

{$IFNDEF D6}
procedure TacRSSFeedCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacRSSFeedCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;


{ TacRSSFeedContainerCompEditor }
procedure TacRSSFeedContainerCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 3 then
    ExecutePropEditor('Feeds')
  else
    inherited ExecuteVerb(Index);
end;

function TacRSSFeedContainerCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacRSSFeedContainerCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then
    Result := '&Show Stored RSS Feeds...'
  else
    if Index = GetVerbCount - 2 then
      Result := '-'
    else
      Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacRSSFeedContainerCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 3) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACEDIT')
  else
    if (Index = GetVerbCount - 2) then
      AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
    else
{$ENDIF}
      inherited PrepareItem(Index, AItem)
end;
{$ENDIF}

{$IFNDEF D6}
procedure TacRSSFeedContainerCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacRSSFeedContainerCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;
{$ENDIF}


{ TacSendRecipientsProperty Editor }
procedure TacSendMailRecipientsProperty.Edit;
begin
  with TacSendMailRecipientEditor.Create(Application) do
   try
     Recipients := GetValue;
     if ShowModal = ID_OK then
      SetValue(Recipients);
   finally
     Free;
   end;
end;


{ TacFileName property }
procedure TacFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{ TacIniFile property }
procedure TacIniFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'INI Files (*.ini)|*.ini|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{ TacXMLFile property }
procedure TacXMLFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'XML Files (*.xml)|*.xml|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{ TacExecutableFileName property }
procedure TacExecutableFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'Executable files|*.exe;*.com;*.bat|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{ TacShorcutFileName property }
procedure TacShortcutFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'Shortcut files (*.lnk)|*.lnk|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{ TacThreadSafeLogFileName property }
procedure TacThreadSafeLogFileNameProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     Filter     := 'Log files (*.log)|*.log|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


// TacFolderProperty
procedure TacFolderProperty.Edit;
var
  TheFolder: String;
begin
  TheFolder := GetValue;
  if SelectDirectory(TheFolder, [sdAllowCreate, sdPerformCreate, sdPrompt], 0) then
   begin
    SetValue(TheFolder);
    Designer.Modified;
   end;
end;

function TacFolderProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;


{ acShortcut Component Editor }
procedure TacShortcutCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
   with TOpenDialog.Create(Application) do
    try
      FileName   := TacShortcut(Component).FileName;
      Title      := 'Select shortcut';
      Filter     := 'Shortcut files (*.lnk)|*.lnk|All files (*.*)|*.*';
      Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
      if Execute then
       begin
        TacShortcut(Component).FileName := FileName;
        Designer.Modified;
       end;
    finally
      Free;
    end
  else inherited ExecuteVerb(Index);
end;
             
function TacShortcutCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacShortcutCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&Select shortcut...'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacShortcutCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 2) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACRESET')
  else
{$ENDIF}  
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ acClipboard Component Editor }
procedure TacClipboardCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    acShowAbout(Component.ClassName)
  else
   if Index = GetVerbCount - 1 then
    begin
     TacClipboard(Component).Clear;
     Designer.Modified;
    end
   else
     inherited ExecuteVerb(Index);
end;

function TacClipboardCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 3;
end;

function TacClipboardCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&About...'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else
     if Index = GetVerbCount - 1 then Result := '&Clear Clipboard'
     else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacClipboardCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if (Index = GetVerbCount - 3) then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
  else
   if (Index = GetVerbCount - 1) then
     AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLOAD')
   else
{$ENDIF}
     inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ acStoredFiles Property Editor }
procedure TacStoredFilesProperty.Edit;
begin
  ShowFileStorageDesigner(Designer, TacFileStorage(GetComponent(0)));
end;

function TacStoredFilesProperty.GetValue: String;
begin
  if TacFileStorage(GetComponent(0)).Files.Count = 0 then
    Result := '(None)'
  else
    Result := '(TStoredFiles)';
end;

function TacStoredFilesProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ acFileStorage Component Editor }
procedure TacFileStorageCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    ShowFileStorageDesigner(Designer, TacFileStorage(Component))
  else inherited ExecuteVerb(Index);
end;

function TacFileStorageCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&Files Designer...'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else Result := inherited GetVerb(Index);
end;

function TacFileStorageCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

{$IFDEF D5}
procedure TacFileStorageCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 3 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACEDIT')
  else
{$ENDIF}  
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacWavPlayerWavFileProperty Editor }
function TacWavPlayerWavFileProperty.GetValue: String;
var
  WaveSound: TStoredFile;
begin
  WaveSound := TacWavPlayer(GetComponent(0)).WaveSound;
  if WaveSound.Data.Memory = nil then
    Result := '(None)'
  else
    Result := '(WAV Sound)'
end;

function TacWavPlayerWavFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TacWavPlayerWavFileProperty.Edit;
var
  WaveSound: TStoredFile;
begin
  WaveSound := TacWavPlayer(GetComponent(0)).WaveSound;

  with TOpenDialog.Create(Application) do
   try
     FileName   := WaveSound.FileName;
     InitialDir := ExtractFilePath(FileName);
     FileName   := ExtractFileName(FileName);
     Filter     := 'WAV files (*.wav)|*.wav|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly];
     if Execute then
      begin
       WaveSound.Upload(FileName);
       TacWavPlayer(GetComponent(0)).SoundType := stCustom;
       Designer.Modified;
      end;
   finally
     Free;
   end;
end;


{ TacWavPlayerEditor }
procedure TacWavPlayerCompEditor.ExecuteVerb(Index: Integer);
var
  WaveSound: TStoredFile;
begin
  if Index = GetVerbCount - 4 then
    TacWavPlayer(Component).Play
  else
   if Index = GetVerbCount - 3 then
    begin
     WaveSound := TacWavPlayer(Component).WaveSound;

     with TOpenDialog.Create(Application) do
      try
        Title      := 'Select Wave-Audio file';
        FileName   := WaveSound.FileName;
        InitialDir := ExtractFilePath(FileName);
        FileName   := ExtractFileName(FileName);
        Filter     := 'WAV files (*.wav)|*.wav|All files (*.*)|*.*';
        Options    := Options + [ofHideReadOnly];
        if Execute then
         begin
          WaveSound.Upload(FileName);
          TacWavPlayer(Component).SoundType := stCustom;
          Designer.Modified;
         end;
      finally
        Free;
      end;
    end
   else inherited ExecuteVerb(Index);
end;

function TacWavPlayerCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 3;
end;

function TacWavPlayerCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 4 then Result := '&Test!'
  else
   if Index = GetVerbCount - 3 then Result := '&Upload WAV Sound...'
   else
    if Index = GetVerbCount - 2 then Result := '-'
    else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacWavPlayerCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 4 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
   if Index = GetVerbCount - 3 then
     AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLOAD')
   else
{$ENDIF}   
     inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{$IFDEF USEINTERNAL}
{$IFDEF D3}
{ TacProgressBoxCompEditor }
procedure TacProgressBoxCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    TacProgressBox(Component).Execute
  else inherited ExecuteVerb(Index);
end;

function TacProgressBoxCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacProgressBoxCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&Test!'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacProgressBoxCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 3 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}
{$ENDIF}
{$ENDIF}


{ TacInfoBoxCompEditor }
procedure TacInfoBoxCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 3 then
    TacInfoBox(Component).Execute(False)
  else inherited ExecuteVerb(Index);
end;

function TacInfoBoxCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacInfoBoxCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 3 then Result := '&Test!'
  else
   if Index = GetVerbCount - 2 then Result := '-'
   else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacInfoBoxCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 3 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacQuickAboutBoxCompEditor }
procedure TacQuickAboutBoxCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 2 then
    TacQuickAboutBox(Component).Execute
  else
    inherited ExecuteVerb(Index);
end;

function TacQuickAboutBoxCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TacQuickAboutBoxCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '&Test...'
  else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacQuickAboutBoxCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 2 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{$IFDEF D3}
{ TacTextTemplateConverterCompEditor }
procedure TacTextTemplateConverterCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 2 then
    ExecutePropEditor('Params')  
  else
    inherited ExecuteVerb(Index);
end;

function TacTextTemplateConverterCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TacTextTemplateConverterCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '&Parameters...'
  else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacTextTemplateConverterCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 2 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACEDIT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}

{$IFNDEF D6}
procedure TacTextTemplateConverterCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacTextTemplateConverterCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;


{ TacLinksPanelCompEditor }
procedure TacLinksPanelCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 2 then
    ExecutePropEditor('Items')  
  else
    inherited ExecuteVerb(Index);
end;

function TacLinksPanelCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TacLinksPanelCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '&Edit Items...'
  else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacLinksPanelCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 2 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}

{$IFNDEF D6}
procedure TacLinksPanelCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacLinksPanelCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;
{$ENDIF}


{ TacURLLabelCompEditor }
procedure TacURLLabelCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 2 then
    TacURLLabel(Component).Execute
  else inherited ExecuteVerb(Index);
end;

function TacURLLabelCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TacURLLabelCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '&Test...'
  else Result := inherited GetVerb(Index);
end;

{$IFDEF D5}
procedure TacURLLabelCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if Index = GetVerbCount - 2 then
    AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACLIGHT')
  else
{$ENDIF}
    inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacSplitterPanelCompEditor }
procedure TacSplitterPanelCompEditor.ExecuteVerb(Index: Integer);
var
  SplitterPanel: TacSplitterPanel;
  TheAlign: TAlign;
  ThePos: Integer;

  function CreatePane(aAlign: TAlign): TacSplitterPanel;
  begin
    Result := TacSplitterPanel.Create(SplitterPanel.Owner);
    with Result do
     begin
      BevelInner := SplitterPanel.BevelInner;
      BevelOuter := SplitterPanel.BevelOuter;
      BevelWidth := SplitterPanel.BevelWidth;
      BorderStyle := SplitterPanel.BorderStyle;
      BorderWidth := SplitterPanel.BorderWidth;
      Cursor := SplitterPanel.Cursor;

      CursorHorz := SplitterPanel.CursorHorz;
      CursorVert := SplitterPanel.CursorVert;
      MinSize := SplitterPanel.MinSize;
      SplitterStyle := SplitterPanel.SplitterStyle;
      SplitterWidth := SplitterPanel.SplitterWidth;

      Name := Designer.UniqueName(TacSplitterPanel.ClassName);
      IsPane := True;
      Align := aAlign;

      Parent := SplitterPanel;
     end;
  end;

begin
  SplitterPanel := TacSplitterPanel(Component);
  if SplitterPanel.IsSplitter then
    inherited ExecuteVerb(Index)
  else
   if Index = GetVerbCount - 5 then
     acShowAbout(Component.ClassName)
   else
    begin
     if Index in [GetVerbCount - 3, GetVerbCount - 2] then
      with SplitterPanel do
       begin
        if Index = GetVerbCount - 3 then // vertical
         begin
          TheAlign := alLeft;
          ThePos := ClientWidth;
         end
        else                             // horizontal
         begin
          TheAlign := alTop;
          ThePos := ClientHeight;
         end;
        Pane1 := CreatePane(TheAlign);
        Pane2 := CreatePane(alClient);
        SplitterPos := (ThePos - SplitterWidth) shr 1;
       end
     else
      if Index = GetVerbCount - 1 then
        SplitterPanel.Free;
     Designer.Modified;
    end;
end;

function TacSplitterPanelCompEditor.GetVerbCount: Integer;
begin
  if TacSplitterPanel(Component).IsSplitter then
    Result := inherited GetVerbCount
  else
    Result := inherited GetVerbCount + 4;
end;

function TacSplitterPanelCompEditor.GetVerb(Index: Integer): String;
begin
  if TacSplitterPanel(Component).IsSplitter then
    Result := inherited GetVerb(Index)
  else
   begin
    if Index = GetVerbCount - 1 then Result := '&Delete Pane'        else
    if Index = GetVerbCount - 2 then Result := 'Split &Horizontally' else
    if Index = GetVerbCount - 3 then Result := 'Split &Vertically'   else
    if Index = GetVerbCount - 4 then Result := '-'                   else
    if Index = GetVerbCount - 5 then Result := 'About...'
    else Result := inherited GetVerb(Index);
   end;
end;

{$IFDEF D5}
procedure TacSplitterPanelCompEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
{$IFNDEF D6}
  if TacSplitterPanel(Component).IsSplitter then
    inherited PrepareItem(Index, AItem)
  else
   if Index = GetVerbCount - 1 then
     AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACDELETE')
   else
    if Index = GetVerbCount - 2 then
      AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACHSPLIT')
    else
     if Index = GetVerbCount - 3 then
       AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACVSPLIT')
     else
      if Index = GetVerbCount - 5 then
        AItem.Bitmap.Handle := LoadBitmap(hInstance, 'ACABOUT')
      else
{$ENDIF}      
       inherited PrepareItem(Index, AItem)
end;
{$ENDIF}


{ TacTreeViewCompEditor }
procedure TacTreeViewCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 6 then ExecutePropEditor('Items')
  else
   if (Index = GetVerbCount - 4) and ((Component is TCustomTreeView) or (Component is TacTreeComboBox)) then
    with TOpenDialog.Create(Application) do
     try
       Filter     := 'TXT Files (*.txt)|*.txt|All files (*.*)|*.*';
       DefaultExt := 'txt';
       Options    := Options + [ofHideReadOnly, ofNoDereferenceLinks];
       if Execute then
         if Component is TCustomTreeView then
           TCustomTreeView(Component).LoadFromFile(FileName)
         else
           TacTreeComboBox(Component).TreeView.LoadFromFile(FileName);
     finally
       Free;
     end
   else
    if (Index = GetVerbCount - 3) and ((Component is TCustomTreeView) or (Component is TacTreeComboBox)) then
     with TSaveDialog.Create(Application) do
      try
        Filter     := 'TXT Files (*.txt)|*.txt|All files (*.*)|*.*';
        DefaultExt := 'txt';
        Options    := Options + [ofHideReadOnly, ofOverwritePrompt, ofNoDereferenceLinks];
        if Execute then
          if Component is TCustomTreeView then
            TCustomTreeView(Component).SaveToFile(FileName)
          else
            TacTreeComboBox(Component).TreeView.SaveToFile(FileName);  
      finally
        Free;
      end                
     else inherited ExecuteVerb(Index);
end;

function TacTreeViewCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 5;
end;

function TacTreeViewCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '-'
  else
   if Index = GetVerbCount - 3 then Result := '&Save to File...'
   else
    if Index = GetVerbCount - 4 then Result := '&Load from File...'
    else
     if Index = GetVerbCount - 5 then Result := '-'
     else
      if Index = GetVerbCount - 6 then Result := '&Items Editor...'
      else Result := inherited GetVerb(Index);
end;

{$IFNDEF D6}
procedure TacTreeViewCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacTreeViewCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;


{ TacListViewCompEditor }
procedure TacListViewCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 3 then ExecutePropEditor('Items')
  else
   if Index = GetVerbCount - 4 then ExecutePropEditor('Columns')
   else inherited ExecuteVerb(Index);
end;

function TacListViewCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 3;
end;

function TacListViewCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '-'
  else
   if Index = GetVerbCount - 3 then Result := '&Items Editor...'
   else
    if Index = GetVerbCount - 4 then Result := 'Col&umns Editor...'
    else Result := inherited GetVerb(Index);
end;

{$IFNDEF D6}
procedure TacListViewCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacListViewCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;


{$IFDEF USEDB}
{ TacDBListViewCompEditor }
procedure TacDBListViewCompEditor.ExecuteVerb(Index: Integer);

  procedure ExecutePropEditor(const APropName: String);
  var
    Components: IComponents;
  begin
    FPropName := APropName;
    Components := TComponents.Create;
    try
      Components.Add(Component);
      GetComponentProperties(Components, [tkClass], Designer,
        FindProperty{$IFDEF D6}, nil{$ENDIF});
    finally
{$IFNDEF D6}
      Components.Free;
{$ENDIF}
    end;
  end;

begin
  if Index = GetVerbCount - 3 then ExecutePropEditor('Columns')
  else inherited ExecuteVerb(Index);
end;

function TacDBListViewCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

function TacDBListViewCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 2 then Result := '-'
  else
   if Index = GetVerbCount - 3 then Result := 'Col&umns Editor...'
   else Result := inherited GetVerb(Index);
end;

{$IFNDEF D6}
procedure TacDBListViewCompEditor.FindProperty(PropertyEditor: TPropertyEditor);
{$ELSE}
procedure TacDBListViewCompEditor.FindProperty(const PropertyEditor: IProperty);
{$ENDIF}
begin
  if PropertyEditor.GetName = FPropName then PropertyEditor.Edit;
{$IFNDEF D6}
  PropertyEditor.Free;
{$ENDIF}
end;
{$ENDIF}


{ TacWallpaperProperty Editor }
function TacWallpaperProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TacWallpaperProperty.Edit;
begin
  with TOpenDialog.Create(Application) do
   try
     FileName   := GetValue;
     InitialDir := ExtractFilePath(FileName);
     FileName   := ExtractFileName(FileName);
     Filter     := 'Wallpaper Bitmaps (*.bmp)|*.bmp|All files (*.*)|*.*';
     Options    := Options + [ofHideReadOnly];
     if Execute then SetValue(FileName);
   finally
     Free;
   end;
end;


{$IFDEF D5}
function TacImageIndexProperty.GetImages: TCustomImageList;
var
  TreeView: TTreeView;
begin
  Result := GetPropPointerValue(GetComponent(0), 'ImageList');
  if Result = nil then
   begin
    Result := GetPropPointerValue(GetComponent(0), 'Images');
    if Result = nil then
     if GetComponent(0) is TacPanelBitBtn then
       Result := TacPanelBitBtn(GetComponent(0)).Button.Images
     else
       if GetComponent(0) is TacPersistent then
        with TacPersistent(GetComponent(0)) do
         begin
          TreeView := GetPropPointerValue(Owner, 'TreeView');
          if Assigned(TreeView) then
            Result := TreeView.Images
         end
       else
         if GetComponent(0) is TacLinksPanelItem then
           Result := TacLinksPanelItem(GetComponent(0)).Panel.ImageList;
   end;
end;

function TacImageIndexProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList];
end;

procedure TacImageIndexProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
begin
//  Proc('-1');
  if Images = nil then Exit;
  I := 0;
  while I < Images.Count do
   begin
    Proc(IntToStr(I));   
    Inc(I);
   end;
end;

procedure TacImageIndexProperty.ListMeasureWidth(const Value: String; ACanvas: TCanvas;
  var AWidth: Integer);
begin
  inherited;
  if Images <> nil then Inc(AWidth, 1 + Images.Width + 1);
end;

procedure TacImageIndexProperty.ListMeasureHeight(const Value: String; ACanvas: TCanvas;
  var AHeight: Integer);
begin
  inherited;
  if (Images <> nil) and (AHeight < 1 + Images.Height + 1) then
    AHeight := 1 + Images.Height + 1;
end;

procedure TacImageIndexProperty.ListDrawValue(const Value: String; ACanvas: TCanvas;
  const ARect: TRect; ASelected: Boolean);
var
  ATextRect: TRect;
begin
  ATextRect := ARect;
  if Images <> nil then
   begin
    Inc(ATextRect.Left, 1 + Images.Width + 1);
    with ARect do
      ACanvas.FillRect(Rect(Left, Top, ATextRect.Left, Bottom));
    Images.Draw(ACanvas, ARect.Left + 1, ARect.Top + 1, StrToInt(Value));
   end;
  with ATextRect, ACanvas do
    ACanvas.TextRect(ATextRect, Left + 1, (Top + Bottom - TextHeight(Value)) shr 1, Value);
end;
{$ENDIF}


procedure Register;
begin
  RegisterComponents('App Controls', [TacAppAutoRun,            {+}
                                      TacAppStartCounter,       {+}
                                      TacCronJob,               {+}
                                      TacAccurateTimer,         {+}
                                      TacAwayTimer,             {+}
                                      TacAppEvents,             {+}
                                      TacAppCursors,            {+}
                                      TacOnlyOne,               {+}
                                      TacTrayIcon,              {+}
                                      TacShortcut,              {+}
                                      TacExtAssociation,        {+}
                                      TacClipboard,             {+}
                                      TacSendMail,              {+}
                                      TacAutoUpgrader,          {+}
                                      TacHTTP,                  {+}
{$IFDEF D4}
                                      TacHTTPDownloadQueue,     { }
                                      TacRSSFeed,               { }
                                      TacRSSFeedContainer,      { }
{$ENDIF}
                                      TacAppBar,                {+}
                                      TacCaptionButton,         {+}
                                      TacAnimationEffect,       {+}
                                      TacWin2kEffects,          {+}
                                      TacFormHelp,              {+}
                                      TacFormHints,             {+}
                                      TacFormMagnet,            {+}
                                      TacFormSystemMenu,        {+}
                                      TacFormTopmost,           {+}
                                      TacFormRoller,            {+}
                                      TacFormPlacementSaver,    {+}
                                      TacFormSizeRestrictions,  {+}
                                      TacFormResizeGrip,        {+}
                                      TacFormBackground,        {+}
                                      TacFormHook,              {+}
                                      TacEmbeddedForm,          {+}
                                      TacFileStorage,           {+}
                                      TacWavPlayer,             {+}
                                      TacCursorLocker,          {+}
                                      TacThread,                {+}
                                      TacThreadSafeLog,         {+}
                                      TacInfoBox,               { }
                                      TacAppGlobalAlert,        { }
                                      TacAppGlobalSwitch        { }
{$IFDEF D4}                           ,
{$IFNDEF BCB}
                                      TacProcessList,           {+}
{$ENDIF}
                                      TacConnectionList         {+}
{$IFDEF D5}
                                     ,TacIESniffer,             {+}
                                      TacIESnifferAutoFillUserInfo {+}
{$ENDIF}{$ENDIF}
                                      ]);

  RegisterComponents('App Controls ++', [TacLabel,             {b!}
{$IFDEF USEINTERNAL}
                                         TacImageLabel,
{$ENDIF}
                                         TacURLLabel,          {+?}
                                         TacRichLabel,         {+!}
                                         TacCheckBox,          {+?}
                                         TacRadioButton,       {+?}
                                         TacButton,            {+?}
                                         TacBitBtn,            {b!}
                                         TacButtonsPanel,      { }
{$IFDEF USEINTERNAL}
                                         TacGroupBox,          {-}
{$ENDIF}
                                         TacCheckGroupBox,     {+?}
{$IFDEF USEINTERNAL}
                                         TacCustomPanel,
                                         TacPanel,
{$ENDIF}
                                         TacSplitterPanel,     { }
                                         TacHeaderPanel,       { }
                                         TacPicturePanel,      { }
{$IFDEF D3}
                                         TacLinksPanel,        { }
{$ENDIF}
                                         TacDragPanel,         {+?}
{$IFNDEF D3}
                                         TacSplitter,          { }
{$ENDIF}
                                         TacEdit,              {+?}
                                         TacNumberEdit,        {+?}
                                         TacCurrencyEdit,      { }                                         
                                         TacIPEdit,            {+?}
                                         TacComboDatePicker,   {+}
                                         TacLabeledComboBox,   { }
                                         TacMRUComboBox,       {+?}
                                         TacImagesComboBox,    { }
                                         TacTreeComboBox,      { }
                                         TacTreeView,          {+?}
                                         TacListView,          {+?}
{$IFDEF USEDB}
                                         TacDBListView,        {+}
{$ENDIF}
                                         TacTrackBar,
{$IFDEF D5}
                                         TacApartPopupMenu,    {}
{$ENDIF}                                         
                                         TacSystemImageList,   {+?}
                                         TacProportionalImage, { }
                                         TacWebImage,          { }
{$IFDEF USEINTERNAL}
                                         TacListImage,
{$ENDIF}
                                         TacStatusControl,     {+?}
                                         TacHeader,            { }
{$IFDEF D5}
{$IFDEF USEINTERNAL}
                                         TacInternalHTMLViewer,{}
{$ENDIF}
                                         TacHTMLViewer,        {}
//                                         TacPopupHTMLViewer,   {}
{$ENDIF}
                                         TacSystemInfo,        {+?}
                                         TacDateTimeCalc,      {+?}
                                         TacUnixCrypt,         {+}
                                         TacStringListContainer,{ }
{$IFDEF D3}
                                         TacTextTemplateConverter, {}
{$ENDIF}                                                                                  
{$IFDEF USEDB}
                                         TacSQLQueryThread,    { }
{$ENDIF}
{$IFDEF USEINTERNAL}
{$IFDEF D5}
                                         TacMySQLClientComponent,
                                         TacMySQLConnectorListContainer,
                                         TacMySQLListComboBox,
                                         TacMySQLCategoryListComboBox,                                         
{$ENDIF}
{$ENDIF}
                                         TacSimpleTCPServer,   {}
                                         TacSimpleTCPClient,   {}
                                         TacHostnameResolver,  {}
{$IFDEF USEINTERNAL}
                                         TacAdvertising,
{$IFDEF D5}
                                         TacRichMediaAd,
                                         TacPopupAd,
                                         TacIERedirector,
{$ENDIF}
{$ENDIF}
                                         TacControlKeyState,   {+?}
                                         TacDesktopWallpaper,  {+?}
{$IFDEF USEINTERNAL}{$IFDEF D3}
                                         TacProgressBox,
                                         TacToolButton,
{$ENDIF}{$ENDIF}
                                         TacTimeChangeNotify,
                                         TacQuickAboutBox]);   {+}
{$IFDEF USEINTERNAL}{$IFDEF D3}
  RegisterNoIcon([TacToolButton]);
{$ENDIF}{$ENDIF}  

  RegisterComponentEditor(TacComponent, TacComponentEditor);
  RegisterComponentEditor(TacAppStartCounter, TacAppStartCounterCompEditor);
  RegisterComponentEditor(TacShortcut, TacShortcutCompEditor);
  RegisterComponentEditor(TacClipboard, TacClipboardCompEditor);  
  RegisterComponentEditor(TacAutoUpgrader, TacAutoUpgraderCompEditor);
{$IFDEF D4}
  RegisterComponentEditor(TacRSSFeed, TacRSSFeedCompEditor);
  RegisterComponentEditor(TacRSSFeedContainer, TacRSSFeedContainerCompEditor);  
{$ENDIF}    
  RegisterComponentEditor(TacFileStorage, TacFileStorageCompEditor);
  RegisterComponentEditor(TacWavPlayer, TacWavPlayerCompEditor);
{$IFDEF USEINTERNAL}{$IFDEF D3}
  RegisterComponentEditor(TacProgressBox, TacProgressBoxCompEditor);
{$ENDIF}{$ENDIF}
  RegisterComponentEditor(TacInfoBox, TacInfoBoxCompEditor);
  RegisterComponentEditor(TacQuickAboutBox, TacQuickAboutBoxCompEditor);

  RegisterComponentEditor(TacBaseLabel, TacComponentEditor);
  RegisterComponentEditor(TacURLLabel, TacURLLabelCompEditor);
  RegisterComponentEditor(TacCheckBox, TacComponentEditor);
  RegisterComponentEditor(TacRadioButton, TacComponentEditor);
  RegisterComponentEditor(TacGroupBox, TacComponentEditor);
  RegisterComponentEditor(TacCustomPanel, TacComponentEditor);
  RegisterComponentEditor(TacSplitterPanel, TacSplitterPanelCompEditor);
  RegisterComponentEditor(TacDragPanel, TacComponentEditor);  
//  RegisterComponentEditor(TacButton, TacComponentEditor);
  RegisterComponentEditor(TacCustomEdit, TacComponentEditor);
  RegisterComponentEditor(TacIPEdit, TacComponentEditor);
  RegisterComponentEditor(TacComboBox, TacComponentEditor);
  RegisterComponentEditor(TacImagesComboBox, TacComponentEditor);
  RegisterComponentEditor(TacTreeComboBox, TacTreeViewCompEditor);
  RegisterComponentEditor(TacTreeView, TacTreeViewCompEditor);
  RegisterComponentEditor(TacListView, TacListViewCompEditor);
  RegisterComponentEditor(TacTrackBar, TacComponentEditor);  
{$IFDEF USEDB}
  RegisterComponentEditor(TacDBListView, TacDBListViewCompEditor);
{$ENDIF}
  RegisterComponentEditor(TacSystemImageList, TacComponentEditor);
  RegisterComponentEditor(TacProportionalImage, TacComponentEditor);
{$IFDEF D3}
  RegisterComponentEditor(TacLinksPanel, TacLinksPanelCompEditor);
  RegisterComponentEditor(TacTextTemplateConverter, TacTextTemplateConverterCompEditor);  
{$ENDIF}
{$IFDEF D5}
{$IFNDEF BCB}
  RegisterComponentEditor(TacHTMLViewer, TacComponentEditor);
{$IFDEF USEINTERNAL}
  RegisterComponentEditor(TacInternalHTMLViewer, TacComponentEditor);
  RegisterComponentEditor(TacCustomAdvertising, TacComponentEditor);
  RegisterComponentEditor(TacListImage, TacComponentEditor);
{$ENDIF}
{$ENDIF}
{$ENDIF}

  RegisterPropertyEditor(TypeInfo(String), TacComponent, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacAppEvents, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacFormSystemMenu, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacBaseLabel, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacCheckBox, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacRadioButton, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacCustomPanel, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacDragPanel, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacGroupBox, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacButton, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacCustomEdit, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacIPEdit, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacComboBox, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacImagesComboBox, 'About', TacAboutProperty);
//  RegisterPropertyEditor(TypeInfo(String), TacTreeComboBox, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacTreeView, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacListView, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacTrackBar, 'About', TacAboutProperty);  
{$IFDEF D5}
  RegisterPropertyEditor(TypeInfo(String), TacApartPopupMenu, 'About', TacAboutProperty);
{$ENDIF}    
{$IFDEF USEDB}
  RegisterPropertyEditor(TypeInfo(String), TacDBListView, 'About', TacAboutProperty);
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(String), TacSystemImageList, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacProportionalImage, 'About', TacAboutProperty);
{$IFDEF D5}
{$IFNDEF BCB}
  RegisterPropertyEditor(TypeInfo(String), TacHTMLViewer, 'About', TacAboutProperty);
{$ENDIF}
{$ENDIF}  
{$IFDEF USEINTERNAL}
  RegisterPropertyEditor(TypeInfo(String), TacListImage, 'About', TacAboutProperty);
  RegisterPropertyEditor(TypeInfo(String), TacAdvertising, 'About', TacAboutProperty);
{$IFDEF D5}
  RegisterPropertyEditor(TypeInfo(String), TacRichMediaAd, 'About', TacAboutProperty);
{$ENDIF}  
{$IFDEF D3}
  RegisterPropertyEditor(TypeInfo(String), TacProgressBox, 'MsgFail', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacProgressBox, 'MsgSuccess', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacSubProgressBox, 'MsgFail', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacSubProgressBox, 'MsgSuccess', TacMultilineStringProperty);
{$ENDIF}
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(String), TacClipboard, 'ClipboardText', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TPersistent, 'Text', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacAutoRunLogonNotice, 'Text', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacAutoUpgraderInfo, 'MsgText', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacSendMail, 'MsgBody', TacMultilineStringProperty);
{$IFDEF D4}
  RegisterPropertyEditor(TypeInfo(String), TacRSSFeedElements, 'Title', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacRSSFeedElements, 'Description', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacRSSFeedItem, 'Title', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacRSSFeedItem, 'Description', TacMultilineStringProperty);
{$ENDIF}  
  RegisterPropertyEditor(TypeInfo(TCaption), TCustomLabel, 'Caption', TacMultilineStringProperty);
{$IFDEF USETHEMEENGINE}
  RegisterPropertyEditor(TypeInfo(WideString), TTeLabel, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(WideString), TacBaseLabel, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(WideString), TacRichLabel, 'Caption', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(WideString), TacAttachedLabel, 'Caption', TacMultilineStringProperty);
{$ELSE}
  RegisterPropertyEditor(TypeInfo(TCaption), TacBaseLabel, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacRichLabel, 'Caption', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacAttachedLabel, 'Caption', TacMultilineStringProperty);  
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(String), TacTrayIcon, 'WhatsThisHint', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(String), TacInfoBox, 'Text', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacPanel, 'Caption', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(String), TacPanel, 'Text', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacHeader, 'RightCaption', TacRichTextProperty);  
  RegisterPropertyEditor(TypeInfo(TCaption), TacCheckBox, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacRadioButton, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacButton, 'Caption', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TacBitBtn, 'Caption', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(String), TacCustomListView, 'EmptyListMessage', TacMultilineStringProperty);
  RegisterPropertyEditor(TypeInfo(String), TacQuickAboutBox, 'Copyright', TacRichTextProperty);
  RegisterPropertyEditor(TypeInfo(String), TacQuickAboutBox, 'Description', TacRichTextProperty);

  RegisterPropertyEditor(TypeInfo(TacHTTPProxy), TacCustomHTTP, 'Proxy', TacHTTPProxyProperty);
{$IFDEF D4}
  RegisterPropertyEditor(TypeInfo(TacHTTPProxy), TacHTTPDownloadQueue, 'Proxy', TacHTTPProxyProperty);
  RegisterPropertyEditor(TypeInfo(TacHTTPProxy), TacRSSFeed, 'HTTPProxy', TacHTTPProxyProperty);
  RegisterPropertyEditor(TypeInfo(TacHTTPProxy), TacRSSFeedContainer, 'HTTPProxy', TacHTTPProxyProperty);
{$ENDIF}
{$IFDEF AUTOUPGRADERPROXY}
  RegisterPropertyEditor(TypeInfo(TacHTTPProxy), TacAutoUpgrader, 'Proxy', TacHTTPProxyProperty);
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(TacAutoUpgraderInfo), TacAutoUpgrader, 'InfoFile', TacAutoUpgraderProperty);
{$IFDEF D3}
  RegisterPropertyEditor(TypeInfo(String), TacAutoUpgrader, 'VersionDate', TacAutoUpgraderVersionDateProperty);
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(String), TacSendMail, 'ToAddr', TacSendMailRecipientsProperty);
  RegisterPropertyEditor(TypeInfo(String), TacSendMail, 'ToCC', TacSendMailRecipientsProperty);
  RegisterPropertyEditor(TypeInfo(String), TacSendMail, 'ToBCC', TacSendMailRecipientsProperty);
  RegisterPropertyEditor(TypeInfo(String), TacCustomHTTP, 'OutputFileName', TacFileNameProperty);  
{$IFDEF D4}
  RegisterPropertyEditor(TypeInfo(String), TacRSSFeedContainer, 'FileName', TacFileNameProperty);
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(String), TacStorageFile, 'FileName', TacXMLFileNameProperty);
  RegisterPropertyEditor(TypeInfo(String), TacRegistrySaver, 'IniFileName', TacIniFileNameProperty);
  RegisterPropertyEditor(TypeInfo(String), TacExtAssociation, 'ExecutableFile', TacExecutableFileNameProperty);
  RegisterPropertyEditor(TypeInfo(String), TacShortcut, 'FILENAME', TacShortcutFileNameProperty);
  RegisterPropertyEditor(TypeInfo(String), TacThreadSafeLog, 'FileName', TacThreadSafeLogFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TStoredFiles), TacFileStorage, 'Files', TacStoredFilesProperty);
  RegisterPropertyEditor(TypeInfo(TStoredFile), TacWavPlayer, 'WaveSound', TacWavPlayerWavFileProperty);
  RegisterPropertyEditor(TypeInfo(String), TacDesktopWallpaper, 'Wallpaper', TacWallpaperProperty);
{$IFDEF D4}
  RegisterPropertyEditor(TypeInfo(String), TacHTTPDownloadQueue, 'TargetFolder', TacFolderProperty);
  RegisterPropertyEditor(TypeInfo(String), TacDownloadQueueTempFiles, 'TempFolder', TacFolderProperty);
{$ENDIF}  

  // ImageIndex for D5/6
{$IFDEF D5}
  RegisterPropertyEditor(TypeInfo(TacImageIndex), TPersistent, '', TacImageIndexProperty);
{$ENDIF}

  RegisterPropertyEditor(TypeInfo(TacIcon), TPersistent, '', TacGraphicProperty);                     

  // ...and some read-only (but visible at design-time) properties
  RegisterPropertyEditor(TypeInfo(Boolean), TacAppAutoRun, 'AutoRun', TacROEnumProperty);
  RegisterPropertyEditor(TypeInfo(Boolean), TacHostnameResolver, 'HostnameResolver', TacROEnumProperty);
  RegisterPropertyEditor(TypeInfo(TStringList), TacClipboard, 'AvailableFormats', TacROStringListProperty);
  RegisterPropertyEditor(TypeInfo(Integer), TacStringListContainer, 'Count', TacROIntegerProperty);
{$IFDEF D6}
  RegisterPropertyEditor(TypeInfo(TIcon), TacExtAssociation, '', TacROGraphicProperty);
{$ENDIF}

  acFormHelpReg.Register;
{$IFDEF D6}
  acIDEEditorsD6.Register;
{$ELSE}
  acIDEEditors.Register;
{$ENDIF}
end;

end.
